#!/usr/bin/env node


const fs = require("fs");
const path = require("path");
const creat_argv = require("nv-cli-basic");

const {pairl2d,fshow} = require("nv-facutil-basic");

const _eng = require("./index");


const cfg = {
    alias: {
        'dbname'          :'N',
        'tblname'         :'t', 
        'desc'            :'D', 
        'cond'            :'c',   
        'srch_ptrn'       :'s',
        'oper'            :'o',
        'action'          :'a',
        'list'            :'l', 
        'ids'             :'i',
        'help'            :'h',
    },
    description: {
        'dbname'          :'database name',
        'tblname'         :'table name',
        'desc'            :'desc name,default ___dflt___',
        'cond'            :'js-style condition where str ,refer to nv-pg-ir, default null',
        'srch_ptrn'       :'full text srch ptrn,default "" ', 
        'oper'            :'OR|AND ,cond <binop> srch_ptrn,default AND',
        'list'            :'list all actions', 
        'action'          :'action,default delete_with_match', 
        'ids'             :'id list',
        'help':"usage",
    },
    string:["desc","srch_ptrn","oper","cond","tbl","action"],
    boolean: ["help","list"],
    defaults: {
        desc:"___dflt___",
        cond:null,
        srch_ptrn:"",
        oper:"AND",
        action:"delete_with_match"
    }
}



var argv = creat_argv(cfg);
////


if(argv.h) {
    var _usage = argv.usage("nv_pg_dispersed_delete");
    console.log(_usage)
} else {
    let p;
    if(argv.l) {
        console.log(Object.keys(_eng))
    } else {
       if(argv.a === 'delete_with_match') { 
           let paramd = {
                   tbl: argv.t,
                   cond: argv.c,
                   srch_ptrn: argv.s,
                   oper:      argv.o,
                   desc: argv.D
           }        
           p = _eng.delete_with_match(argv.N,paramd);   
       } else if(argv.a === 'delete_with_ids') {
           let paramd = {
                   tbl: argv.t,
                   ids: argv.i
           }
           p = _eng.delete_with_ids(argv.N,paramd);
       } else {
       }
    }
    ////-----
    if(p) {
            p.then(
                r => fshow(r)
            ).catch(
                err=>console.log(err)
            ).finally(
                ()=>process.exit()
            )
    } else {}
}
